using Statistics
using Tracker
inputs = [0.2, -0.3, 0.5, 1, -0.9]
outputs = [-0.2, 0.3, -0.5, -1, 0.9]
weight = 0.4

predict(inputs, weight) = inputs .* weight
loss(inputs, outputs, weight) = 
    mean((outputs - (inputs .* weight)).^2)
dloss(inputs, outputs, weight) = 
    Tracker.data(
        Tracker.gradient(loss, inputs, outputs, weight)[3])
for i in 1:100
    println("現在の予測: $(predict(inputs, weight))")
    println("現在の損失: $(loss(inputs, outputs, weight))")
    println("現在の重み: $(weight)")
    d = dloss(inputs, outputs, weight)
    global weight -= d * 0.1
end
